config/routes.rb
Rails.application.routes.draw do
  resources :conversations do
    resource :conversation_user
    resources :messages
  end
  resources :reservations, path_names: { new: 'new/:location_id' }
  resources :favoris, path_names: { new: 'new/:location_id' }
  resources :avis, path_names: { new: 'new/:location_id' }
  resources :categories
  resources :equipements, path_names: { new: 'new/:location_id' }
  devise_for :users
  resources :locations
  resources :searches
  # For details on the DSL available within this file, see https://guides.rubyonrails.org/routing.html
  root to: "locations#index"
end

app/models/conversation.rb
class Conversation < ApplicationRecord
    has_many :conversation_users, dependent: :destroy
    has_many :users, through: :conversation_users
    has_many :messages, dependent: :destroy

    validates :name, presence: true
end

app/controllers/conversations_controller.rb
class ConversationsController < ApplicationController
  before_action :authenticate_user!, except: [:index]
  before_action :set_conversation, only: %i[ show edit update destroy ]

  # GET /conversations or /conversations.json
  def index
    @conversations = Conversation.all
  end

  # GET /conversations/1 or /conversations/1.json
  def show
  end

  # GET /conversations/new
  def new
    @conversation = Conversation.new
  end

  # GET /conversations/1/edit
  def edit
  end

  # POST /conversations or /conversations.json
  def create
    @conversation = Conversation.new(conversation_params)

    respond_to do |format|
      if @conversation.save
        format.html { redirect_to conversation_url(@conversation), notice: "Conversation was successfully created." }
        format.json { render :show, status: :created, location: @conversation }
      else
        format.html { render :new, status: :unprocessable_entity }
        format.json { render json: @conversation.errors, status: :unprocessable_entity }
      end
    end
  end

  # PATCH/PUT /conversations/1 or /conversations/1.json
  def update
    respond_to do |format|
      if @conversation.update(conversation_params)
        format.html { redirect_to conversation_url(@conversation), notice: "Conversation was successfully updated." }
        format.json { render :show, status: :ok, location: @conversation }
      else
        format.html { render :edit, status: :unprocessable_entity }
        format.json { render json: @conversation.errors, status: :unprocessable_entity }
      end
    end
  end

  # DELETE /conversations/1 or /conversations/1.json
  def destroy
    @conversation.destroy

    respond_to do |format|
      format.html { redirect_to conversations_url, notice: "Conversation was successfully destroyed." }
      format.json { head :no_content }
    end
  end

  private
    # Use callbacks to share common setup or constraints between actions.
    def set_conversation
      @conversation = Conversation.find(params[:id])
    end

    # Only allow a list of trusted parameters through.
    def conversation_params
      params.require(:conversation).permit(:name)
    end
end

app/helpers/conversations_helper.rb
module ConversationsHelper
end

app/views/conversations/_form.html.erb
<%= form_with(model: conversation) do |form| %>
  <% if conversation.errors.any? %>
    <div id="error_explanation">
      <h2><%= pluralize(conversation.errors.count, "error") %> prohibited this conversation from being saved:</h2>

      <ul>
        <% conversation.errors.each do |error| %>
          <li><%= error.full_message %></li>
        <% end %>
      </ul>
    </div>
  <% end %>

  <div class="field">
    <%= form.label :name %>
    <%= form.text_field :name %>
  </div>

  <div class="actions">
    <%= form.submit %>
  </div>
<% end %>

app/views/conversations/edit.html.erb
<h1>Editing Conversation</h1>

<%= render 'form', conversation: @conversation %>

<%= link_to 'Show', @conversation %> |
<%= link_to 'Back', conversations_path %>

app/views/conversations/index.html.erb
<p id="notice"><%= notice %></p>

<h1>Conversations</h1>

<table>
  <thead>
    <tr>
      <th>Name</th>
      <th colspan="3"></th>
    </tr>
  </thead>

  <tbody>
    <% @conversations.each do |conversation| %>
      <tr>
        <td><%= conversation.name %></td>
        <td><%= link_to 'Show', conversation %></td>
        <td><%= link_to 'Edit', edit_conversation_path(conversation) %></td>
        <td><%= link_to 'Destroy', conversation, method: :delete, data: { confirm: 'Are you sure?' } %></td>
      </tr>
    <% end %>
  </tbody>
</table>

<br>

<%= link_to 'New Conversation', new_conversation_path %>

app/views/conversations/new.html.erb
<h1>New Conversation</h1>

<%= render 'form', conversation: @conversation %>

<%= link_to 'Back', conversations_path %>

app/views/conversations/show.html.erb
<div class="row">
  <div class="col-sm-2">
    <div class="d-flex justify-content-between">
    <h6>Conversations</h6>
    <%= link_to "Créer un conversation", new_conversation_path, :class => "btn btn-success", :style => "color: white" %>

    <% Conversation.all.each do |conversation| %>
      <div>
        <%= link_to conversation.name, conversation %>
        <% if current_user.conversations.include?(@conversation) %>
          <%= link_to "Supprimer la conversation", conversation_conversation_user_path(conversation), :class => "btn btn-danger", :style => "color: white", method: :delete %>
        <% end %>
      </div>
    <% end %>

    <hr />

    <div class="d-flex justify-content-between">
      <h6>User</h6>
    </div>
    <% @conversation.users.each do |user| %>
      <div>
        <%= user.email %>
      </div>
    <% end %>

  </div>

  <div class="col-sm-10">
    <% if current_user.conversations.include?(@conversation) %>
      <% form_with model: [@conversation, Message.new] do |form| %>
        <% form.text_field :body, class: "form-control" %>
      <% end %>
    <% else %>
      <%= link_to "join #{@conversation.name}", conversation_conversation_user_path(@conversation), method: :post %>
    <% end %>
  </div>
</div>